/*================================== for deals api ======================================*/
var lat = localStorage.getItem('userlat');
var lng = localStorage.getItem('userlng');
var usertoken = localStorage.token;
var FBtoken = localStorage.accessToken;
var stack = true;

/*============================== Get Current position ==================================*/

$(document).ready(function() {
    if (typeof usertoken != "undefined") {
        myFunction();
    }
    if (typeof FBtoken != "undefined") {
        myFunction();
        $('.dealsettings ul li:nth-child(3)').show();
        $('.dealsettings ul li:nth-child(4)').show();
    }

    /*================================ click event for categories ==================================*/

    $('.categoryTiles li').click(function() {
        var category = $(this).data('category');
        var justDeals = '<li id="${id}" data-id="${id}" data-cid="${company.id}" data-companyfav="${isCompanyFavoured}" data-favorite="${isDealFavoured}" data-hidecompany="${isCompanyHidden}" data-recommended="${isRecommended}" data-price="${hidePrice}" data-discount="${hideDiscount}" ><div class="dealsImg"> <a><img src="${mainImage.path}" alt=""></a><br/></div><div class="dealsInfo"><div class="dealsBreif"><h3 data-dealid="${id}">${name}</h3><p class="companyTitle">${company.name}</p></div><div class="dealsIcons"><ul><li><a class="priceDiscount"><img src="images/empty.png" alt="" class="discountImg">${discount}<span class="discountPercent">%</span></a><span>${priceAfterDiscount} kr.</span></li><li><a class="navigation"><img src="images/distance.png" alt=""></a><span>${distance} km</span></li><li><a class="moresettings"><img src="images/newmenu.png" alt=""></a><span>Menu</span></li></ul></div></div><div class="dealsettings"><ul><li data="images/profile_icon2.png" class="favorite_company"><a><img src="images/favcompany.png" alt="" class="itemimg"><span class="deal-txt"> Følg virksomhed</span></a></li><li data="images/favdeal_hover.png" class="favorite_deal"><a><img src="images/favdeal.png" alt="" class="itemimg"><span class="deal-txt">Gem opslag</span></a></li><li data="images/thumbIcon_hover.png" class="Recommend_deal_nearest"><a><img src="images/thumbIcon.png" alt="" class="itemimg"><span> Like </span></a></li><li data="images/shareicon_hover.png" class="share_deal"><a href="share.html"><img src="images/shareicon.png" alt="" class="itemimg"><span> Send til ven</span></a></li><li data="images/hideicon_hover.png" class="hide-company hideCompaniess"><a><img src="images/hideicon.png" alt="" class="itemimg"> <span>Skjul virksomhed</span></a></li><li data="images/backBtn_hover.png"><a class="back"><img src="images/backBtn.png" alt="" class="itemimg"> Tilbage</a></li></ul></div></li>';
        $.template("justDealTemp", justDeals);

        var url;
        if (typeof usertoken != "undefined") {
            url = 'http://rappit.dk/api/deals.json?category=' + category + '&token=' + usertoken + '&latitude=' + lat + '&longitude=' + lng;
        }
        if (typeof FBtoken != "undefined") {
            url = 'http://rappit.dk/api/deals.json?category=' + category + '&ftoken=' + FBtoken + '&latitude=' + lat + '&longitude=' + lng;
        }

        $.ajax({
            url: url,
            type: "GET",
            datatype: 'JSON',
            beforeSend: function() {
                $('.overlay-loader').show();
            },
            success: function(data) {
                var deals = data;
                $('.newest, .categorynearest').empty();
                $('.nearest, .categorynewest').empty();
                $.tmpl('justDealTemp', deals).appendTo(".categorynearest");
                $.tmpl('justDealTemp', deals).appendTo(".categorynewest");
                $('.categoryTiles').hide();
                $('.categoryList ul:first-child').show();
                $('.categoryTabs span:first-child').addClass('selected');
                $('.categoryTabs span:last-child').removeClass('selected');
            },
            error:function(){
                // TODO
            },
            complete:function(){
                $('.overlay-loader').hide();
            }
        }).done(function() {
            if (usertoken) {
                $('.dealsettings ul li:nth-child(3)').hide();
                $('.dealsettings ul li:nth-child(4)').hide();
                $('.dealsettings').css({
                    'height': '220px !important'
                });
            }
            if (localStorage.accessToken) {
                $('.dealsettings ul li:nth-child(3)').show();
                $('.dealsettings ul li:nth-child(4)').show();
            }

            $('.back').click(function(e) {
                e.preventDefault();
                $('.overlay').hide();
                $('.dealsettings').hide();
            });

            /***************** For favorite companies *****************/
            CompanyFavs();

            /***************** For favorite deals ********************/
            DealsFavs();

            /***************** For hiding the companies ****************/
            HideCompanies();

            /***************** For recommend the deals ****************/
            RecommendedDeals();

            /***************** For share the deals ****************/
            ShareDeal();

            /***************** redirect to deal details & company profile ****************/
            companyDetails();
            dealsDetails();

            $('.moresettings').click(function(e) {
                conditionCheck(event);
                $('.overlay').show(0);
                $(this).closest('.dealsInfo').next('.dealsettings').show(0);
                $('.dealsettings ul').show(0);
                e.preventDefault();
            });

            // Leave out price and discount categorynearest

            $('.categoryList > ul > li').each(function() {
                var hidePrice = $(this).attr('data-price');
                var hideDiscount = $(this).attr('data-discount');
                $(this).children().find('.discountPercent').replaceWith('%');
            });

        });
    });
});

//============================ Deals Function ================================

function myFunction() {
    var justDeals = '<li data-id="${id}" data-cid="${company.id}" data-companyfav="${isCompanyFavoured}" data-favorite="${isDealFavoured}" data-hidecompany="${isCompanyHidden}" data-recommended="${isRecommended}" data-price="${hidePrice}" data-discount="${hideDiscount}" ><div class="dealsImg"> <a><img src="${mainImage.path}" alt=""></a><br/></div><div class="dealsInfo"><div class="dealsBreif"><h3 data-dealid="${id}">${name}</h3><p class="companyTitle">${company.name}</p></div><div class="dealsIcons"><ul><li><a class="priceDiscount"><img src="images/empty.png" alt="" class="discountImg">${discount}<span class="discountPercent">%</span></a><span>${priceAfterDiscount} kr.</span></li><li><a class="navigation"><img src="images/distance.png" alt=""></a><span>${distance} km</span></li><li><a class="moresettings"><img src="images/newmenu.png" alt=""></a><span>Menu</span></li></ul></div></div><div class="dealsettings"><ul><li data="images/profile_icon2.png" class="favorite_company"><a><img src="images/favcompany.png" alt="" class="itemimg"><span class="deal-txt"> Følg virksomhed</span></a></li><li data="images/favdeal_hover.png" class="favorite_deal"><a><img src="images/favdeal.png" alt="" class="itemimg"><span class="deal-txt">Gem opslag</span></a></li><li data="images/thumbIcon_hover.png" class="Recommend_deal_nearest"><a><img src="images/thumbIcon.png" alt="" class="itemimg"><span> Like</span></a></li><li data="images/shareicon_hover.png" class="share_deal"><a><img src="images/shareicon.png" alt="" class="itemimg"><span> Send til ven</span></a></li><li data="images/hideicon_hover.png" class="hide-company hidc" data-tab="newest"><a><img src="images/hideicon.png" alt="" class="itemimg"> <span>Skjul virksomhed</span></a></li><li data="images/backBtn_hover.png"><a class="back"><img src="images/backBtn.png" alt="" class="itemimg"> Tilbage</a></li></ul></div></li>';
    var vipDeals = '<li data-id="${id}" data-cid="${company.id}" data-companyfav="${isCompanyFavoured}" data-favorite="${isDealFavoured}" data-hidecompany="${isCompanyHidden}" data-recommended="${isRecommended}" data-price="${hidePrice}" data-discount="${hideDiscount}" ><div class="dealsImg"> <a><img src="${mainImage.path}" alt=""> <img src="images/vip.png" alt="" class="vip"></a><br/></div><div class="dealsInfo"><div class="dealsBreif"><h3 data-dealid="${id}">${name}</h3><p class="companyTitle">${company.name}</p></div><div class="dealsIcons"><ul><li><a class="priceDiscount"><img src="images/empty.png" alt="" class="discountImg">${discount}<span class="discountPercent">%</span></a><span>${priceAfterDiscount} kr.</span></li><li><a class="navigation"><img src="images/distance.png" alt=""></a><span>${distance} km</span></li><li><a class="moresettings"><img src="images/newmenu.png" alt=""></a><span>Menu</span></li></ul></div></div><div class="dealsettings"><ul><li data="images/profile_icon2.png" class="favorite_company"><a><img src="images/favcompany.png" alt="" class="itemimg"><span class="deal-txt"> Følg virksomhed</span></a></li><li data="images/favdeal_hover.png" class="favorite_deal"><a><img src="images/favdeal.png" alt="" class="itemimg"><span class="deal-txt">Gem opslag</span></a></li><li data="images/thumbIcon_hover.png" class="Recommend_deal_nearest"><a><img src="images/thumbIcon.png" alt="" class="itemimg"><span> Like</span></a></li><li data="images/shareicon_hover.png" class="share_deal"><a><img src="images/shareicon.png" alt="" class="itemimg"><span> Send til ven</span></a></li><li data="images/hideicon_hover.png" class="hide-company" data-tab="newest"><a><img src="images/hideicon.png" alt="" class="itemimg"> <span>Skjul virksomhed</span></a></li><li data="images/backBtn_hover.png"><a class="back"><img src="images/backBtn.png" alt="" class="itemimg"> Tilbage</a></li></ul></div></li>';
    $.template("justDealTemp", justDeals);
    $.template("vipDealTemp", vipDeals);

    var tokenurl;
    if (typeof usertoken != "undefined") {
        tokenurl = 'http://rappit.dk/api/deals.json?token=' + usertoken + '&latitude=' + lat + '&longitude=' + lng;
    }
    if (typeof FBtoken != "undefined") {
        tokenurl = 'http://rappit.dk/api/deals.json?ftoken=' + FBtoken + '&latitude=' + lat + '&longitude=' + lng;
    }

    $.ajax({
        datatype: 'JSON',
        url: tokenurl,
        jsonp: "$callback",
        beforeSend: function() {
            $('.overlay-loader').show();
        },
        success: function(data) {
            $('.overlay-loader').hide();
            var deals = data;
            $('.newest').empty();
            if (data.isVIP == true) {
                $.tmpl('vipDealTemp', deals).appendTo(".newest");
            } else {
                $.tmpl('justDealTemp', deals).appendTo(".newest");
            }
        },
        // error: function(data) {
        //     $('.overlay-loader').hide();
        // }
    }).done(function(data) {
        if (usertoken) {
            $('.dealsettings ul li:nth-child(3)').hide();
            $('.dealsettings ul li:nth-child(4)').hide();
        }
        if (localStorage.accessToken) {
            $('.dealsettings ul li:nth-child(3)').show();
            $('.dealsettings ul li:nth-child(4)').show();
        }

        $('.back').click(function(e) {
            e.preventDefault();
            $('.overlay').hide();
            $('.dealsettings').hide();
        });


        /***************** For favorite companies *****************/
        CompanyFavs();

        /***************** For favorite deals ********************/
        DealsFavs();

        /***************** For hiding the companies ****************/
        HideCompanies();

        /***************** For recommend the deals ****************/
        RecommendedDeals();

        /***************** For share the deals ****************/
        ShareDeal();

        /***************** redirect to deal details & company profile ****************/
        companyDetails();
        dealsDetails();

        $('.moresettings').click(function(e) {
            conditionCheck(event);
            $('.overlay').show();
            $(this).closest('.dealsInfo').next('.dealsettings').show();
            $('.dealsettings ul').show();
            e.preventDefault();
        });

        $('.newest > li[data-hidecompany="true"]').hide();
        if ($(this).attr('data-tab') == 'newest') {
            $('ul.newest').css('display', 'block');
        }

        $('.dealsList > ul > li').each(function() {
            $(this).children().find('.discountPercent').replaceWith('%');
        });
    });
}

//============================= Company Favorites Function ================================
function CompanyFavs() {
    $('.dealsettings > ul > li.favorite_company').click(function (e) {
        e.preventDefault();
        var companyfavorite = $(this).parents('li').attr('data-companyfav');
        var companyFavoriteStatus = $(this).parents('li');
        var companyid = $(this).parents('li').data('cid');

        var urlCompany;
        if (typeof usertoken != "undefined") {
            urlCompany = 'http://rappit.dk/api/company/favs.json?token=' + usertoken;
        }
        if (typeof FBtoken != "undefined") {
            urlCompany = 'http://rappit.dk/api/company/favs.json?ftoken=' + FBtoken;
        }

        var itemVal = $(this).attr('data');
        $(this).children('a').children('.itemimg').attr('src', itemVal);
        var itemCode = $(this).attr('data');
        
        if (companyfavorite === "false") {
            // alert(1);
            $(this).children('.itemImg').attr('src', itemCode + '_hover');
            $.ajax({
                url: urlCompany,
                type: "POST",
                data: {id: companyid},
                datatype: "JSON",
                cache: false,
                beforeSend: function () {
                    // $('.overlay-loader').show();
                },
                success: function (data) {
                    // $('.overlay-loader').hide();

                    $(companyFavoriteStatus).attr('data-companyfav', "true");
                    $('.favorite_company img').attr('src', 'images/profile_icon2.png');
                    $('.dealsettings ul li.favorite_company a span').html('FJERN SOM FAVORIT');
                },
                // error(function() {
                // });
            });
        } else if (companyfavorite === "true") {
            // alert(2);
            $(this).children('.itemimg').attr('src', itemVal);
            $.ajax({
                url: urlCompany,
                type: "DELETE",
                data: {id: companyid},
                datatype: "JSON",
                cache: false,
                beforeSend: function () {
                    // $('.overlay-loader').show();
                },
                success: function (data) {
                    // $('.overlay-loader').hide();
                    $(companyFavoriteStatus).attr('data-companyfav', "false");
                    $('.favorite_company img').attr('src', 'images/favcompany.png');
                    $('.dealsettings ul li.favorite_company a span').html('Følg virksomhed');
                },
            });
        }
    });
}

//============================= Favorite Deals Function ===================================

function DealsFavs() {
    $('.dealsettings > ul > li.favorite_deal').click(function (e) {
        e.preventDefault();
        var dealfavorite = $(this).parents('li').attr('data-favorite');
        var dealFavoriteStatus = $(this).parents('li');
        var dealid = $(this).parents('li').data('id');

        var url;
        if (typeof usertoken != "undefined") {
            url = 'http://rappit.dk/api/deals/favs.json?token=' + usertoken;
        }
        if (typeof FBtoken != "undefined") {
            url = 'http://rappit.dk/api/deals/favs.json?ftoken=' + FBtoken;
        }

        var itemVal = $(this).attr('data');
        $(this).children('a').children('.itemimg').attr('src', itemVal);
        var itemCode = $(this).attr('data');

        if (dealfavorite === "false") {
            $(this).children('.itemImg').attr('src', itemCode + '_hover');
            $.ajax({
                url: url,
                type: "POST",
                data: {id: dealid},
                datatype: "JSON",
                cache: false,
                beforeSend: function () {
                    // $('.overlay-loader').show();
                },
                success: function (data) {
                    // $('.overlay-loader').hide();
                    $(dealFavoriteStatus).attr('data-favorite', "true");
                    $('.favorite_deal img').attr('src', 'images/favdeal_hover.png');
                    $('.dealsettings ul li.favorite_deal a span').html('FJERN FRA GEMTE OPSLAG');
                }
            })
        } else {
            $(this).children('.itemimg').attr('src', itemVal);
            $.ajax({
                url: url,
                type: "DELETE",
                data: {id: dealid},
                datatype: "JSON",
                cache: false,
                beforeSend: function () {
                    // $('.overlay-loader').show();
                },
                success: function (data) {
                    // $('.overlay-loader').hide();
                    $(dealFavoriteStatus).attr('data-favorite', "false");
                    $('.favorite_deal img').attr('src', 'images/favdeal.png');
                    $('.dealsettings ul li.favorite_deal a span').html('Gem opslag');
                }
            });
        }
    });
}

//===================================== Hide Function with Click ===================================

function HideCompanies() {
    $('.hidc, .hideCompaniess, .nhc, .shc').click(function(e) {
        e.preventDefault();
        var hiddenCompany = $(this).parents('li').attr('data-hidecompany');
        var hiddenCompanyStatus = $(this).parents('li');
        var company = $(this).parents('li');
        var companyid = company.data('cid');
        if (hiddenCompany == 'false' && stack == true) {
            stack = false;
            navigator.notification.confirm(
                'Er du sikker på, at du vil skjule virksomheden?',
                function(button) {
                    if (button == 1) {
                        HiddenCompanies(hiddenCompany, hiddenCompanyStatus, company, companyid);
                    }
                    stack = true;
                }, 'Bekræft', 'Ok,Annuler' // title
            );
        };
    });
}

//============================= Company Hidden Function ===================================

function HiddenCompanies(hiddenCompany, hiddenCompanyStatus, company, companyid) {
    var urlHideCompany;
    if (typeof usertoken != "undefined") {
        urlHideCompany = 'http://rappit.dk/api/company/hide.json?token=' + usertoken;
    }
    if (typeof FBtoken != "undefined") {
        urlHideCompany = 'http://rappit.dk/api/company/hide.json?ftoken=' + FBtoken;
    }

    var itemVal = $(this).attr('data');
    $(this).children('a').children('.itemimg').attr('src', itemVal);
    var itemCode = $(this).attr('data');

    if (hiddenCompany === "false") {
        $(this).children('.itemimg').attr('src', itemCode + '_hover');
        $.ajax({
            url: urlHideCompany,
            type: "POST",
            datatype: "JSON",
            data: {
                id: companyid
            },
            cache: false,
            beforeSend: function() {
                // $('.overlay-loader').show();
            },
            success: function(data) {
                $(hiddenCompanyStatus).attr('data-hidecompany', data.status);
                $(this).parents('.dealsettings').show();
            },
        }).done(function() {
            $('.dealsList li[data-cid="' + companyid + '"]').hide();
            // $('.overlay-loader,.overlay').hide();
        });
    } else {
        $(this).children('.itemimg').attr('src', itemVal);
        $.ajax({
            url: urlHideCompany,
            type: "DELETE",
            datatype: "JSON",
            data: {
                id: companyid
            },
            cache: false,
            beforeSend: function() {
                $('.overlay-loader').show();
            },
            success: function(data) {
                $(hiddenCompanyStatus).attr('data-hidecompany', data.status);
                $('.hide-company img').attr('src', 'images/hideicon.png');
                $('.dealsettings ul li.hide-company a span').html('Skjul Virksomhed');
                $('.overlay-loader,.overlay').hide();
            }
        }).done(function() {
            $('.dealsList li[data-cid="' + companyid + '"]').hide();
            $('.overlay-loader,.overlay').hide();
        });
    }
    // });
}

//============================= Share Deal Function(FB login Only) ========================

function ShareDeal() {
    $('.share_deal').click(function(e) {
        e.preventDefault();
        var shareDeal = $(this).parent().closest("li");
        var dealId = $(this).parents('li').attr('data-id');
        var cId = $(this).parents('li').attr('data-cid');
        var companyFav = $(this).parents('li').attr('data-companyfav');
        location.href = "share.html";
        localStorage.setItem("cid", cId);
        localStorage.setItem("dealId", dealId);
        localStorage.setItem('sharedeal', shareDeal[0].outerHTML);
        localStorage.setItem('companyfav', companyFav);
    });
}

//============================= Like Function (FB Login Only) =============================

function RecommendedDeals() {
    $('.dealsettings > ul > li.Recommend_deal_nearest').click(function (e) {

        e.preventDefault();
        var RecommendDeal = $(this).parents('li').attr('data-recommended');
        var RecommendStatus = $(this).parents('li');
        var dealid = $(this).parents('li').data('id');

        var urlRecommended = 'http://rappit.dk/api/deal/reccommend.json?ftoken=' + FBtoken + '&id=' + dealid;

        var itemVal = $(this).attr('data');
        $(this).children('a').children('.itemimg').attr('src', itemVal);
        var itemCode = $(this).attr('data');
        
        if (RecommendDeal === "false") {
            $(this).children('.itemImg').attr('src', itemCode + '_hover');
            $.ajax({
                url: urlRecommended,
                type: "POST",
                datatype: "JSON",
                data: {id: dealid},
                cache: false,
                beforeSend: function () {
                    // $('.overlay-loader').show();
                },
                success: function (data) {
                    // $('.overlay-loader').hide();
                    $(RecommendStatus).attr('data-recommended', "true");
                    $('.Recommend_deal_nearest img').attr('src', 'images/thumbIcon_hover.png');
                    $('.Recommend_deal_nearest a span').html('FJERN LIKE');
                }
            });
        } else {
            $(this).children('.itemimg').attr('src', itemVal);
            $.ajax({
                url: urlRecommended,
                type: "DELETE",
                datatype: "JSON",
                data: {id: dealid},
                cache: false,
                beforeSend: function () {
                    // $('.overlay-loader').show();
                },
                success: function (data) {
                    // $('.overlay-loader').hide();
                    $(RecommendStatus).attr('data-recommended', "false");
                    $('.Recommend_deal_nearest img').attr('src', 'images/thumbIcon.png');
                    $('.Recommend_deal_nearest a span').html('Like');
                }
            });
        }
    });
}

//============================= Condition Check Function ==================================

function conditionCheck(event) {
    var self = $(event.currentTarget);
    var dealfavorite = self.parent().parent().parent().parent().parent().attr('data-favorite');
    if (dealfavorite === "true") {
        //        alert("fav " + dealfavorite);
        self.closest('.dealsInfo').next().find('.favorite_deal img').attr('src', 'images/favdeal_hover.png');
        $('.dealsettings ul li.favorite_deal a span').html('FJERN FRA GEMTE OPSLAG');
    } else {
        //        alert("fav " + dealfavorite);
        self.closest('.dealsInfo').next().find('.favorite_deal img').attr('src', 'images/favdeal.png');
        $('.dealsettings ul li.favorite_deal a span').html('Gem opslag');
    }

    var companyfavorite = self.parent().parent().parent().parent().parent().attr('data-companyfav');
    if (companyfavorite === "true") {
        //        alert("cmp " + companyfavorite);
        self.closest('.dealsInfo').next().find('.favorite_company img').attr('src', 'images/favcompany_hover.png');
        $('.dealsettings ul li.favorite_company a span').html('FJERN SOM FAVORIT');
    }
    if (companyfavorite === "false") {
        //        alert("cmp " + companyfavorite);
        self.closest('.dealsInfo').next().find('.favorite_company img').attr('src', 'images/favcompany.png');
        $('.dealsettings ul li.favorite_company a span').html('Følg virksomhed');
    }

    var RecommendDeal = self.parent().parent().parent().parent().parent().attr('data-recommended');
    if (RecommendDeal === "true") {
        self.closest('.dealsInfo').next().find('.Recommend_deal_nearest a img').attr('src', 'images/thumbIcon_hover.png');
        $('.dealsettings ul li.Recommend_deal_nearest a span').html('FJERN LIKE');
    }

    if (RecommendDeal === "false") {
        self.closest('.dealsInfo').next().find('.Recommend_deal_nearest a img').attr('src', 'images/thumbIcon.png');
        $('.dealsettings ul li.Recommend_deal_nearest a span').html('Like');
    }
}

// ================================ Deals Details and Company Details Functions =============================

function dealsDetails() {
    $('.dealsBreif h3').click(function () {
        var dealId = $(this).parent().parent().parent().attr('data-id');
        var cId = $(this).parent().parent().parent().attr('data-cid');
        location.href = "deals-details.html";
        localStorage.setItem("dealId", dealId);
        localStorage.setItem("cid", cId);
    });

    $('.dealdescription').click(function () {
        var dealId = $(this).prev().attr('data-dealid');
        var cId = $(this).parents('li').attr('data-cid');
        location.href = "deals-details.html";
        localStorage.setItem("dealId", dealId);
        localStorage.setItem("cid", cId);
    });

    $('.dealsImg a img').click(function () {
        var dealId = $(this).parents('li').attr('data-id');
        var cId = $(this).parents('li').attr('data-cid');
        location.href = "deals-details.html";
        localStorage.setItem("dealId", dealId);
        localStorage.setItem("cid", cId);
    });
}

function companyDetails() {
	  $('p.companyTitle').click(function(e) {
		    e.preventDefault();
		    location.href = "companyprofile.html";
		    var cId = $(this).parent().parent().parent().attr('data-cid');
		    localStorage.setItem("cid", cId);
	  });
}
