/********************* For hidden companies ************************/
var usertoken = localStorage.token;
var FBtoken = localStorage.accessToken;

$(document).ready(function() {

    var hideCompany = '<li data-id="${id}"><a href="javascript:void()"><img src="${logo.path}" class="details" alt=""><span>VIS</span></a><p><a href="#">${name}</a></p></li>';
    $.template("hideCompanyTemp", hideCompany);
    var urlRemoveHideCompany;

    if (typeof usertoken != "undefined") {
        urlRemoveHideCompany = 'http://rappit.dk/api/company/hide.json?token=' + usertoken;
    }
    if (typeof FBtoken != "undefined") {
        urlRemoveHideCompany = 'http://rappit.dk/api/company/hide.json?ftoken=' + FBtoken;
    }

    $.ajax({
        datatype: 'JSON',
        url: urlRemoveHideCompany,
        jsonp: "$callback",
        cache: false,
        beforeSend: function() { $('.overlay-loader').show(); },
        success: function(data) {
	    if(data.length===0){
		$('<li> <strong>Du skjulte ingen opslag</stron></li>').appendTo(".hidden-company-list");
	    } else {
		$('.overlay-loader').hide();
		var hide = data;
		$('.hidden-company-list').empty();
		$.tmpl('hideCompanyTemp', hide).appendTo(".hidden-company-list");
	    }
	}
    }).done(function() {
        $('.hidden-company-list li a span').click(function() {
            var y = $(this).parent().parent();
            var companyid = $(this).parent().parent().attr('data-id');
            navigator.notification.confirm(
                'Skal virksomheden igen vises?', function(button) {
                    if (button == 1) {
                        HiddenCompanies(y,companyid);
                        $('.overlay-loader').hide();
                        $(y).remove();
                    }
                }, 'Bekræft', 'Ok,Annuler' // title
            );
        });

        $('.hidden-company-list li img.details').click(function() {
            var cId = $(this).parent().parent().attr('data-id');
            location.href = "companyprofile.html";
            localStorage.setItem("cid", cId);
        });
    });
}); //End of hidecompanies js

function HiddenCompanies(y,companyid){
    if (typeof usertoken != "undefined") {
        urlRemoveHideCompany = 'http://rappit.dk/api/company/hide.json?token=' + usertoken;
    }
    if (typeof FBtoken != "undefined") {
        urlRemoveHideCompany = 'http://rappit.dk/api/company/hide.json?ftoken=' + FBtoken;
    }

    $.ajax({
        url: urlRemoveHideCompany,
        type: "DELETE",
        datatype: "JSON",
        data: { id: companyid },
        beforeSend: function() { $('.overlay-loader').show(); },
        success: function(data) {
            $('.overlay-loader').hide();
            $(y).remove();
        }
    });
}
