 var lat = localStorage.getItem('userlat');
 var lng = localStorage.getItem('userlng');
 // var lat = '55.6761';
 // var lng = '12.5683';
 var usertoken = localStorage.token;
 var FBtoken = localStorage.accessToken;
 var searchKey;

 /************************* Ajax for Nearest deals ********************************/
 $(document).ready(function() {
     if (typeof FBtoken != "undefined") {
         $('.dealsettings ul li:nth-child(3)').show();
         $('.dealsettings ul li:nth-child(4)').show();
     }
 });

 $('.search').focus(function() {
     $('.SearchCloseBtn').show();
 });

 $('.SearchCloseBtn').click(function() {
     $('.search').val('');
     $(this).hide();
     $('.search').blur();
     $('.bottomFixedBar').css({"position":"fixed","bottom":"0px"});
 });

 //======================================= Search Function ====================================
 $('.searchForm').submit(function(e) {

     searchKey = $('.search').val();

     $('#overlay').click(function() {
         $('.dealstabs').hide();
         $('.dealsList').css({
             'margin-top': '0px'
         }); 
         $('.search').focus(function() {
             $('.search').val('');
             $('.SearchCloseBtn').show();
         }); 
         $('.newest, .nearest, .dealstabs').hide();
     });

     if (searchKey == '') {
         // $('.SearchCloseBtn').hide();
     } else {
         $('.SearchCloseBtn').show();
         $('.searchPanel').show();
         searchFunction();
     }

     function searchFunction() {
         $('.search').blur();
         var searchList = '<li data-id="${id}" data-cid="${company.id}" data-companyfav="${isCompanyFavoured}" data-favorite="${isDealFavoured}" data-hidecompany="${isCompanyHidden}" data-recommended="${isRecommended}" data-price="${hidePrice}" data-discount="${hideDiscount}" ><div class="dealsImg"><a><img src="${mainImage.path}" alt=""></a><br/></div><div class="dealsInfo"><div class="dealsBreif"><h3 data-dealid="${id}">${name}</h3><p class="companyTitle">${company.name}</p></div><div class="dealsIcons"><ul><li><a class="priceDiscount"><img src="images/empty.png" alt="" class="discountImg">${discount}%<span class="discountPercent"></span></a><span>${price} kr.</span></li><li><a class="navigation"><img src="images/distance.png" alt=""></a><span>${distance} km</span></li><li><a class="moresettings"><img src="images/newmenu.png" alt=""></a><span>Menu</span></li></ul></div></div><div class="dealsettings"><ul><li data="images/profile_icon2.png" class="favorite_company"><a><img src="images/favcompany.png" alt="" class="itemimg"><span class="deal-txt"> Følg virksomhed</span></a></li><li data="images/favdeal_hover.png" class="favorite_deal"><a><img src="images/favdeal.png" alt="" class="itemimg"><span class="deal-txt">Gem opslag</span></a></li><li data="images/thumbIcon_hover.png" class="Recommend_deal_nearest"><a><img src="images/thumbIcon.png" alt="" class="itemimg"><span> Like </span></a></li><li data="images/shareicon_hover.png" class="share_deal"><a href="share.html"><img src="images/shareicon.png" alt="" class="itemimg"><span>Send til ven</span></a></li><li data="images/hideicon_hover.png" class="hide-company shc"><a><img src="images/hideicon.png" alt="" class="itemimg"> <span>Skjul virksomhed</span></a></li><li data="images/backBtn_hover.png"><a class="back"><img src="images/backBtn.png" alt="" class="itemimg"> Tilbage</a></li></ul></div></li>';
         $.template("searchTmp", searchList);

         var tokenurl;
         if (typeof usertoken != "undefined") {
             tokenurl = 'http://rappit.dk/api/deals.json?token=' + usertoken + '&keyword=' + searchKey + '&latitude=' + lat + '&longitude=' + lng;
         } else if (typeof FBtoken != "undefined") {
             tokenurl = 'http://rappit.dk/api/deals.json?ftoken=' + FBtoken + '&keyword=' + searchKey + '&latitude=' + lat + '&longitude=' + lng;
         }

         $.ajax({
             datatype: "JSON",
             url: tokenurl,
             jsonp: "$callback",
             beforeSend: function() {
                 $('.overlay-loader').show();
             },
             success: function(data) {
                 $('.dealstabs, .tabs1').hide();
                 $('.dealsList').css({
                     'margin-top': '0px'
                 });
                 $('.newest, .nearest, .categorynearest, .categorynewest, .categoryTiles').hide();

                 $('.searchPanel, .searchResults').show();
                 $('.overlay-loader').hide();
                 var searchData = data;
                 $('.searchResults').empty();
                 if (data.length == 0) {
                     $('.inbox_empty').show();
                 } else {
                     $('.inbox_empty').hide();
                     $.tmpl('searchTmp', searchData).appendTo(".searchResults");
                 }
             }
         }).done(function() {
             if (usertoken) {
                 $('.dealsettings ul li:nth-child(3)').hide();
                 $('.dealsettings ul li:nth-child(4)').hide();
                 $('.dealsettings').css({
                     'height': '220px !important'
                 });
             }
             if (localStorage.accessToken) {
                 $('.dealsettings ul li:nth-child(3)').show();
                 $('.dealsettings ul li:nth-child(4)').show();
             }
             $('.back').click(function(e) {
                 e.preventDefault();
                 $('.overlay').hide();
                 $('.dealsettings').hide();
             });

             /***************** For favorite companies *****************/

             CompanyFavs();

             /***************** For favorite deals ********************/

             DealsFavs();

             /***************** For hiding the companies ****************/

             HideCompanies();

             /***************** For recommend the deals ****************/

             RecommendedDeals();

             /***************** For share the deals ****************/

             ShareDeal();

             /***************** redirect to deal details & company profile ****************/

             companyDetails();
             dealsDetails();

             $('.moresettings').click(function(e) {
                 conditionCheck(e);
                 $('.overlay').show(0);
                 $(this).closest('.dealsInfo').next('.dealsettings').show(0);
                 $('.dealsettings ul').show(0);
                 e.preventDefault();
             });

             // Leave out price and discount

             $('ul.searchResults > li').each(function() {
                 var hidePrice = $(this).attr('data-price');
                 var hideDiscount = $(this).attr('data-discount');

                 if (hidePrice === "true" || hideDiscount === "true") {
                     $(this).children().find('.timer-icon > span:first-child').hide();
                     $(this).children().find('.timer-icon > span:nth-child(2)').hide();
                 } else {
                     $(this).children().find('.timer-icon > span:first-child').show();
                     $(this).children().find('.timer-icon > span:nth-child(2)').show();
                 }

             });

         });
     }
     return false;
 });
