/*============================ Local storage ================================*/

var usertoken = localStorage.token;
var FBtoken = localStorage.accessToken;
var cid;
var dealid;

$(document).ready(function() {

	// Appending the Deal HTML from local storage
	$('.shareDeal ul').html(localStorage.sharedeal);

	// More settings options
	$('.moresettings').click(function(e) {
		e.preventDefault();
		$('.overlay').show();
		$(this).parent().parent().next('.dealsettings').show();
		$('.dealsettings ul').show();
	});
	$('.dealsettings').hide();
	$('.dealsettings ul li:nth-child(4)').hide();

	$('.back').click(function(e) {
		e.preventDefault();
		$('.overlay').hide();
		$('.dealsettings').hide();
	});

	// FB friends list with ids in an array
	var fblist = [];
	var dummylist = [];

	/*============================ FB Graph APIs and Autocomplete =================================*/

	FacebookInAppBrowser.graphApi('/me/friends/?fields=id,installed,name', function(response) {
		if (response) {
			$.each(response.data, function(i, v) {
				var temp = {
					"value": v.id,
					"label": v.name
				};
				fblist.push(temp);
			});
		}
	});

	$('#fb-input').autocomplete({
		source: function(req, response) {
			var re = $.ui.autocomplete.escapeRegex(req.term);
			var matcher = new RegExp( "^" + re, "i" );
			var match =$.grep( fblist, function(item){
				return matcher.test(item.label);
		   	});
			response(match);
		},
		select: function(e, ui) {
			e.preventDefault();
			var FBlist = $('ul.friends-fblist li').length;
			if (FBlist >= 1) {
				var li = $('ul.friends-fblist li');
				var chk = false;
				$('ul.friends-fblist li').each(function(i, v) {
					if (chk === false) {
						if ($(v).data('label') == ui.item.label) {
							navigator.notification.alert(
								'allerede tilføjet',
								callBackFunction, // message
								'Bekræft' // title
							);
							chk = true;
						}
					}
				});
				if (chk === false) {
					$('ul.friends-fblist').append('<li data-uid="' + ui.item.value + '" data-label="' + ui.item.label + '"><button type="button" class="btn btn-default btn-lg"><span>' + ui.item.label + '</span><span class="remove-list"><img src="images/removeicon.png" alt=""></span></button></li>');
					$('#fb-input').val('');
				}
			} else {
				$('ul.friends-fblist').append('<li data-uid="' + ui.item.value + '" data-label="' + ui.item.label + '"><button type="button" class="btn btn-default btn-lg"><span>' + ui.item.label + '</span><span class="remove-list"><img src="images/removeicon.png" alt=""></span></button></li>');
				$('#fb-input').val('');
			}

			$('.remove-list').click(function() {
				$(this).closest('li').remove();
			});
			return false;
		},
		change: function(e, ui) {
			$('#fb-input').val("");
			return false;
		}
	});

	$('#personal-msg').blur(function() {
		$('body').animate({
			scrollTop: $(this).offset().top - (0)
		});
	});

	var friendsId = [];

	$('.share').stop(true, true).on('click', function(e) {
		e.preventDefault();
		var msg = $('#personal-msg').val();
		var FBid = $('.share-group ul li').length;

		if (FBid >= 1) {
			$('.share-group ul li').each(function() {
				var selectedId = $(this).attr('data-uid');
				friendsId.push(selectedId);
			});

			var dataString = 'id=' + localStorage.getItem('dealId') + '&message=' + msg + '&users=' + friendsId;

			$.ajax({
				url: 'http://rappit.dk/api/share.json?ftoken=' + FBtoken,
				type: "POST",
				data: dataString,
				success: function(data) {
					navigator.notification.alert(
						'Beskeden er sendt',
						callBackFunction, // message
						'Bekræft' // title
					);

					function callBackFunction(b) {
						if (b == 1) {
							console.log("user said ok");
						} else {
							console.log("user said Awesome");
						}
					}

					$('#personal-msg').val('');
					$('.share-group ul li').remove();
				},
				error: function(data) {

					navigator.notification.alert(
						'Please try again',
						callBackFunction, // message
						'Bekræft' // title
					);
				}
			}).done(function() {
				location.href = "deals.html";
			});
		} else {
			e.preventDefault();
			navigator.notification.alert(
				'Please select friends to share deal or Message is empty.',
				callBackFunction, // message
				'Bekræft' // title
			);
		}
	});

	/*============================ More Options features =================================*/

	$('.dealsettings > ul > li.favorite_company').click(function(e) {
		e.preventDefault();
		var companyfavorite = $(this).parents('li').attr('data-companyfav');
		var companyFavoriteStatus = $(this).parents('li');
		var companyid = $(this).parents('li').data('cid');

		var urlCompany;
		if (typeof usertoken != "undefined") {
			urlCompany = 'http://rappit.dk/api/company/favs.json?token=' + usertoken;
		}
		if (typeof FBtoken != "undefined") {
			urlCompany = 'http://rappit.dk/api/company/favs.json?ftoken=' + FBtoken;
		}

		var itemVal = $(this).attr('data');
		$(this).children('a').children('.itemimg').attr('src', itemVal);
		var itemCode = $(this).attr('data');

		if (companyfavorite === "false") {
			$(this).children('.itemImg').attr('src', itemCode + '_hover');
			$.ajax({
				url: urlCompany,
				type: "POST",
				data: {
					id: companyid
				},
				datatype: "JSON",
				cache: false,
				beforeSend: function() {
					$('.overlay-loader').show();
				},
				success: function(data) {
					$('.overlay-loader').hide();
					$(companyFavoriteStatus).attr('data-companyfav', data.status);
					$('.dealsettings ul li.favorite_company a span').html('FJERN SOM FAVORIT');
					$('.favorite_company img').attr('src', 'images/profile_icon2.png');
				},
			});
		} else {
			$(this).children('.itemimg').attr('src', itemVal);
			$.ajax({
				url: urlCompany,
				type: "DELETE",
				data: {
					id: companyid
				},
				datatype: "JSON",
				cache: false,
				beforeSend: function() {
					$('.overlay-loader').show();
				},
				success: function(data) {
					$('.overlay-loader').hide();
					$(companyFavoriteStatus).attr('data-companyfav', data.status);
					$('.favorite_company img').attr('src', 'images/favcompany.png');
					$('.dealsettings ul li.favorite_company a span').html('Følg virksomhed');
				},
			});
		}
	});

	/*======================== Global function Deal Favorites function for all ===========================*/

	$('.dealsettings > ul > li.favorite_deal').click(function(e) {
		e.preventDefault();
		var dealfavorite = $(this).parents('li').attr('data-favorite');
		var dealFavoriteStatus = $(this).parents('li');
		var dealid = $(this).parents('li').data('id');

		var url;
		if (typeof usertoken != "undefined") {
			url = 'http://rappit.dk/api/deals/favs.json?token=' + usertoken;
		}
		if (typeof FBtoken != "undefined") {
			url = 'http://rappit.dk/api/deals/favs.json?ftoken=' + FBtoken;
		}

		var itemVal = $(this).attr('data');
		$(this).children('a').children('.itemimg').attr('src', itemVal);
		var itemCode = $(this).attr('data');

		if (dealfavorite === "false") {
			$(this).children('.itemImg').attr('src', itemCode + '_hover');
			$.ajax({
				url: url,
				type: "POST",
				data: {
					id: dealid
				},
				datatype: "JSON",
				cache: false,
				beforeSend: function() {
					// $('.overlay-loader').show();
				},
				success: function(data) {
					// $('.overlay-loader').hide();
					$(dealFavoriteStatus).attr('data-favorite', data.status);
					$('.dealsettings ul li.favorite_deal a span').html('FJERN GEMT OPSLAG');
					$('.favorite_deal img').attr('src', 'images/favdeal_hover.png');
				}
			});
		} else {
			$(this).children('.itemimg').attr('src', itemVal);
			$.ajax({
				url: url,
				type: "DELETE",
				data: {
					id: dealid
				},
				datatype: "JSON",
				cache: false,
				beforeSend: function() {
					// $('.overlay-loader').show();
				},
				success: function(data) {
					// $('.overlay-loader').hide();
					$(dealFavoriteStatus).attr('data-favorite', data.status);
					$('.favorite_deal img').attr('src', 'images/favdeal.png');
					$('.dealsettings ul li.favorite_deal a span').html('Gem opslag');
				}
			});
		}
	});

	/*======================= Global function Recommend company list function for all =====================*/

	$('.dealsettings > ul > li.Recommend_deal_nearest').click(function(e) {
		e.preventDefault();
		var RecommendDeal = $(this).parents('li').attr('data-recommended');
		var RecommendStatus = $(this).parents('li');
		var dealid = $(this).parents('li').data('id');
		var urlRecommended = 'http://rappit.dk/api/deal/reccommend.json?ftoken=' + FBtoken + '&id=' + dealid;

		var itemVal = $(this).attr('data');
		$(this).children('a').children('.itemimg').attr('src', itemVal);
		var itemCode = $(this).attr('data');

		if (RecommendDeal === "false") {
			$(this).children('.itemImg').attr('src', itemCode + '_hover');
			$.ajax({
				url: urlRecommended,
				type: "POST",
				datatype: "JSON",
				data: {
					id: dealid
				},
				cache: false,
				beforeSend: function() {
					// $('.overlay-loader').show();
				},
				success: function(data) {
					// $('.overlay-loader').hide();
					$(RecommendStatus).attr('data-recommended', data.status);
					$('.Recommend_deal_nearest img').attr('src', 'images/thumbIcon_hover.png');
					$('.dealsettings ul li.Recommend_deal_nearest a span').html('FJERN LIKE');
				}
			});
		} else {
			$(this).children('.itemimg').attr('src', itemVal);
			$.ajax({
				url: urlRecommended,
				type: "DELETE",
				datatype: "JSON",
				data: {
					id: dealid
				},
				cache: false,
				beforeSend: function() {
					// $('.overlay-loader').show();
				},
				success: function(data) {
					// $('.overlay-loader').hide();
					$(RecommendStatus).attr('data-recommended', data.status);
					$('.Recommend_deal_nearest img').attr('src', 'images/thumbIcon.png');
					$('dealsettings ul li.Recommend_deal_nearest a span').html('Like');
				}
			});
		}
	});

	/*========================== Global function Hide company list function for all =============================*/

	$('.dealsettings > ul > li.hide-company').click(function(e) {
		e.preventDefault();
		var hiddenCompany = $(this).parents('li').attr('data-hidecompany');
		var hiddenCompanyStatus = $(this).parents('li');
		var company = $(this).parents('li');
		var companyid = company.data('cid');
		var urlHideCompany;
		if (typeof usertoken != "undefined") {
			urlHideCompany = 'http://rappit.dk/api/company/hide.json?token=' + usertoken;
		}
		if (typeof FBtoken != "undefined") {
			urlHideCompany = 'http://rappit.dk/api/company/hide.json?ftoken=' + FBtoken;
		}

		var itemVal = $(this).attr('data');
		$(this).children('a').children('.itemimg').attr('src', itemVal);
		var itemCode = $(this).attr('data');

		if (hiddenCompany === "false") {
			$(this).children('.itemimg').attr('src', itemCode + '_hover');
			$.ajax({
				url: urlHideCompany,
				type: "POST",
				datatype: "JSON",
				data: {
					id: companyid
				},
				cache: false,
				beforeSend: function() {
					// $('.overlay-loader').show();
				},
				success: function(data) {
					$(hiddenCompanyStatus).attr('data-hidecompany', data.status);
					$('.hide-company img').attr('src', 'images/hideicon_hover.png');
					$('.dealsettings ul li.hide-company a span').html('Vis Virksomhed');
					$(this).parents('.dealsettings').show();

				},
			}).done(function() {
				$('.dealsList li[data-cid="' + companyid + '"]').hide();
				// $('.overlay-loader,.overlay').hide();
			});
		} else {
			$(this).children('.itemimg').attr('src', itemVal);
			$.ajax({
				url: urlHideCompany,
				type: "DELETE",
				datatype: "JSON",
				data: {
					id: companyid
				},
				cache: false,
				beforeSend: function() {
					// $('.overlay-loader').show();
				},
				success: function(data) {
					$(hiddenCompanyStatus).attr('data-hidecompany', data.status);
					$('.hide-company img').attr('src', 'images/hideicon.png');
					$('.dealsettings ul li.hide-company a span').html('Send til ven');
					// $('.overlay-loader,.overlay').hide();
				}
			}).done(function() {
				$('.dealsList li[data-cid="' + companyid + '"]').hide();
				// $('.overlay-loader,.overlay').hide();
			});
		}
	});

	/*========================== CONDITION to check true or fasle =========================*/

	var companyfavorite = $(event.currentTarget).parent().parent().parent().attr('data-companyfav');
	if (companyfavorite === "true") {
		$(event.currentTarget).parent().parent().next().find('.favorite_company img').attr('src', 'images/profile_icon2.png');
		$('.dealsettings ul li.favorite_company a span').html('FJERN SOM FAVORIT');
	} else {
		$(event.currentTarget).parent().parent().next().find('.favorite_company img').attr('src', 'images/favcompany.png');
		$('.dealsettings ul li.favorite_company a span').html('Følg virksomhed');
	}

	var dealfavorite = $(event.currentTarget).parent().parent().parent().attr('data-favorite');
	if (dealfavorite === "true") {
		$(event.currentTarget).parent().parent().next().find('.favorite_deal img').attr('src', 'images/favdeal_hover.png');
		$('.dealsettings ul li.favorite_deal a span').html('FJERN GEMT OPSLAG');
	} else {
		$(event.currentTarget).parent().parent().next().find('.favorite_deal img').attr('src', 'images/favdeal.png');
		$('.dealsettings ul li.favorite_deal a span').html('Gem opslag');
	}

	var hiddenCompany = $(event.currentTarget).parent().parent().parent().attr('data-hidecompany');
	if (hiddenCompany === "true") {
		$(event.currentTarget).parent().parent().parent().next().find('.hide-company img').attr('src', 'images/hideicon_hover.png');
		$('.dealsettings ul li.hide-company a span').html('Vis Virksomhed');
	} else {
		$(event.currentTarget).parent().parent().parent().next().find('.hide-company img').attr('src', 'images/hideicon.png');
		$('.dealsettings ul li.hide-company a span').html('Skjul virksomhed');
	}

	var RecommendDeal = $(event.currentTarget).closest('li').attr('data-recommended');
	if (RecommendDeal === "true") {
		$(event.currentTarget).parents('li').next().find('.Recommend_deal img').attr('src', 'images/thumbIcon_hover.png');
		$('.dealsettings ul li.Recommend_deal a span').html('FJERN LIKE');
	} else {
		$(event.currentTarget).parents('li').next().find('.Recommend_deal img').attr('src', 'images/thumbIcon.png');
		$('.dealsettings ul li.Recommend_deal a span').html('Like');
	}

	//=========================================== Link to Deals Details page ==============================================

	$('.dealsBreif h3').click(function() {
		var dealId = $(this).parent().parent().parent().attr('data-id');
		var cId = $(this).parent().parent().parent().attr('data-cid');
		location.href = "deals-details.html";
		localStorage.setItem("dealId", dealId);
		localStorage.setItem("cid", cId);
	});

	$('.dealdescription').click(function() {
		var dealId = $(this).prev().attr('data-dealid');
		var cId = $(this).parents('li').attr('data-cid');
		location.href = "deals-details.html";
		localStorage.setItem("dealId", dealId);
		localStorage.setItem("cid", cId);
	});

	$('.dealsImg a img').click(function() {
		var dealId = $(this).prev().attr('data-dealid');
		var cId = $(this).parents('li').attr('data-cid');
		location.href = "deals-details.html";
		localStorage.setItem("dealId", dealId);
		localStorage.setItem("cid", cId);
	});

	$('.dealsImg p a').click(function(e) {
		e.preventDefault();
		location.href = "companyprofile.html";
		var cId = $(this).parent().parent().parent().attr('data-cid');
		localStorage.setItem("cid", cId);
	});

}); // end of document

$('#fb-input, #personal-msg').focus(function(event) {
	/* Act on the event */
	$('.fixedBar').css({
		'position': 'fixed'
	});

	$('.bottomFixedBar').css({
		'position': 'relative',
		'bottom': '0',
		'display': 'none'
	});

	$('#shareDeal').css({
		'position': 'absolute',
		'display': 'block'
	});
});

$('#fb-input, #personal-msg').blur(function(event) {
	/* Act on the event */
	$('.fixedBar').css({
		'position': 'fixed'
	});

	$('.bottomFixedBar').css({
		'position': 'fixed',
		'display': 'block'
	});
});
