var usertoken = localStorage.token;
var FBtoken = localStorage.accessToken;
var lat = localStorage.getItem('userlat');
var lng = localStorage.getItem('userlng');
var srcImg;
var imgpath;
$(document).ready(function() {
    var dealId = localStorage.dealId;
    var detailsTemplate = '<div class="gallery" id="${id}" data-cid = "${company.id}" data data-fav="${isDealFavoured}" data-recommended="${isRecommended}" data-cfav="${isCompanyFavoured}" data-chide="${isCompanyHidden}" data-price="${hidePrice}" data-discount="${hideDiscount}"><div class="main"><img src="${images[0].path}" alt=""></div><div class="thumbs"><ul><li><img src="${images[1].path}" alt=""></li><li><img src="${images[2].path}" alt=""></li><li><img src="${images[3].path}" alt=""></li></ul></div></div><div class="dealsinfo"><h3><span><a data-coid="${company.id}" class="coclik">${company.name}</a></span></h3><h4>${name}</h4><p>${description}</p></div><div class="btns"><ul><li><a><img src="images/steps.png" alt=""></a><span>Kom</span></li><li><a class="priceDiscount"><img src="images/empty_price.png" alt="" class="discountImg">${discount}<span class="discountPercent">%</span></a><span>${priceAfterDiscount} kr.</span></li><li><a><img src="images/time.png" alt=""></a><span class="slut">${expire}</span></li><li><a href="tel:${phone}"><img src="images/ring.png" alt=""></a><span>Ring</span></li><li><a class="deal-detailsRute" data-navlat="${latitude}" data-navlang="${longitude}" data-navcat="${category}" data-cd="${company.id}"><img src="images/distance.png" alt=""></a><span class="dis">${distance} km</span></li><li><a class="moresettings"><img src="images/newmenu.png" alt=""></a><span>Menu</span></li></ul></div>';
    var openingHours = '<p>${week}<span>${starting} - ${ending}</span></p>';
    $.template("DetailsTemp", detailsTemplate);
    $.template("openingHours", openingHours);
    var urlDetail;
    if (typeof usertoken != "undefined") {
        urlDetail = 'http://rappit.dk/api/deal.json?token=' + usertoken + '&id=' + dealId + '&latitude=' + lat + '&longitude=' + lng;
    }
    if (typeof FBtoken != "undefined") {
        urlDetail = 'http://rappit.dk/api/deal.json?ftoken=' + FBtoken + '&id=' + dealId + '&latitude=' + lat + '&longitude=' + lng;
    }

    function logHours(indexh, data) {
        valueh = data.hours[indexh];
        $.tmpl('openingHours', valueh).appendTo(".opening");
    }
    $.ajax({
        datatype: 'JSON',
        url: urlDetail,
        jsonp: "$callback",
        beforeSend: function() {
            $('.overlay-loader').show();
        },
        success: function(data) {
            srcImg = data.type;
            $('.overlay-loader').hide();
            var dealsDetails = data;
            $('.details').empty();
            $.each(data.hours, function(v, h) {
                indexh = v;
                logHours(indexh, data);
            });
            $.tmpl('DetailsTemp', dealsDetails).appendTo(".details");
        }
    }).done(function() {
        if (srcImg === "byArrival") {
            imgpath = "images/footprints1.png";
            $('.types').attr('src', imgpath);
        }
        if (srcImg === "byCall") {
            imgpath = "images/phone.png";
            $('.types').attr('src', imgpath);
        }
        if (srcImg === "timeFrame") {
            imgpath = "images/events.png";
            $('.types').attr('src', imgpath);
        }
        if (srcImg === "news") {
            imgpath = "images/news.png";
            $('.types').attr('src', imgpath);
        }
        if (typeof(FBtoken) != "undefined") {
            urls = "http://rappit.dk/api/mail/count.json?ftoken=" + FBtoken;
            $.ajax({
                url: urls,
                type: 'GET',
                datatype: 'JSON',
                success: function(data) {
                    localStorage.setItem('inCount', data.totalUnreadMessages);
                    if (data.totalUnreadMessages > 0) {
                        $('.bubbleCounter').show();
                        $('.bubbleCounter').html(data.totalUnreadMessages);
                    } else {
                        $('bubbleCounter').hide();
                    }
                }
            });
        } else {
            $('bubbleCounter').hide();
        }
        $('.settings').html('<div class="dealsettings"><ul><li data="images/profile_icon2.png" class="favorite_company"><a><img src="images/favcompany.png" alt=""> <span>Følg virksomhed</span></a></li><li data="images/favdeal_hover.png" class="favorite_deal"><a><img src="images/favdeal.png" alt=""> <span>Gem opslag</span></a></li><li data="images/thumbIcon_hover.png" class="Recommend_deal"><a><img src="images/thumbIcon.png" alt="" class="rec"> <span class="recText">Like</span></a></li><li data="images/shareicon_hover.png" class="share_deal"><a><img src="images/shareicon.png" alt=""><span> Send til ven</span></a></li><li data="images/hideicon_hover.png" class="hide-company"><a><img src="images/hideicon.png" alt=""> <span>Skjul virksomhed</span></a></li><li data="images/back_fill.png"><a class="back"><img src="images/backBtn.png" alt=""> Tilbage</a></li></ul></div>');
        if (usertoken) {
            $('.dealsettings ul li:nth-child(3)').hide();
            $('.dealsettings ul li:nth-child(4)').hide();
            $('.dealsettings').css({
                'height': '150px !important'
            });
        }
        if (localStorage.accessToken) {
            $('.dealsettings ul li:nth-child(3)').show();
            $('.dealsettings ul li:nth-child(4)').show();
        }
        $('.moresettings').click(function(e) {
            conditionCheck(e);
            $('.overlay').show();
            $(this).parent().parent().next('.dealsettings').show();
            $('.dealsettings').show();
        });
        $('.back').click(function(e) {
            e.preventDefault();
            $('.overlay').hide();
            $('.dealsettings').hide();
        });
        /***************** For favorite companies *****************/
        CompanyFavs();
        /***************** For favorite deals ********************/
        DealsFavs();
        /***************** For hiding the companies ****************/
        // HiddenCompanies();
        $('.dealsettings > ul > li.hide-company').click(function(e) {
            e.preventDefault();
            var hiddenCompany = $(this).parent().parent().parent().parent().find('.gallery').attr('data-chide');
            var hiddenCompanyStatus = $(this).parent().parent().parent().parent().find('.gallery');
            var companyid = localStorage.cid;
            if (hiddenCompany == 'false') {
                navigator.notification.confirm(
                    'Er du sikker på, at du vil skjule virksomheden?',
                    function(button) {
                        if (button == 1) {
                            HiddenCompanies(hiddenCompany, hiddenCompanyStatus, companyid);
                        }
                    }, 'Bekræft', 'Ok,Annuler' // title
                );
            }
            if (hiddenCompany == 'true') {
                navigator.notification.confirm(
                    'Skal virksomheden igen vises?',
                    function(button) {
                        if (button == 1) {
                            HiddenCompanies(hiddenCompany, hiddenCompanyStatus, companyid);
                        }
                    }, 'Bekræft', 'Ok,Annuler' // title
                );
            }
        });
        /***************** For recommend the deals ****************/
        RecommendedDeals();
        /***************** For share the deals ****************/
        ShareDeal();
        /*************** For Company Details *****************/
        companyDetails();
        $('.thumbs ul li img').each(function() {
            $(this).click(function() {
                var thmb = this;
                var src = this.src;
                $('.main img').fadeOut(100, function() {
                    thmb.src = this.src;
                    $(this).fadeIn(100)[0].src = src;
                });
            });
        });
        $('.dealsinfo h3 img').click(function() {
            $('.dealsettings').show();
        });
        $('.deal-detailsRute').click(function(event) {
            navlat = localStorage.setItem('navlat', $(this).attr('data-navlat'));
            navlang = localStorage.setItem('navlang', $(this).attr('data-navlang'));
            navcat = localStorage.setItem('navcat', $(this).attr('data-navcat'));
            var ciod = $(this).attr('data-cd');
            localStorage.setItem('cid', ciod);
            location.href = 'navigate.html';
        });
        $('.gallery').each(function() {
            $(this).parent().find('.discountPercent').replaceWith('%');
        });
    });
});
//============================================ Company Favs ================================================
function CompanyFavs() {
    $('.favorite_company').click(function(e) {
        var companyfavorite = $(this).parent().parent().parent().parent().find('.gallery').attr('data-cfav');
        var companyFavoriteStatus = $(this).parent().parent().parent().parent().find('.gallery');
        var companyid = localStorage.cid;
        var urlCompany;
        if (typeof usertoken != "undefined") {
            urlCompany = 'http://rappit.dk/api/company/favs.json?token=' + usertoken;
        }
        if (typeof FBtoken != "undefined") {
            urlCompany = 'http://rappit.dk/api/company/favs.json?ftoken=' + FBtoken;
        }
        var itemVal = $(this).attr('data');
        $(this).children('a').children('.itemimg').attr('src', itemVal);
        var itemCode = $(this).attr('data');
        if (companyfavorite === "false") {
            $(this).children('.itemImg').attr('src', itemCode + '_hover');
            $.ajax({
                url: urlCompany,
                type: "POST",
                data: {
                    id: companyid
                },
                datatype: "JSON",
                cache: false,
                beforeSend: function() {
                    // $('.overlay-loader').show();
                },
                success: function(data) {
                    // $('.overlay-loader').hide();
                    $(companyFavoriteStatus).attr('data-cfav', "true");
                    $('.favorite_company a span').html('FJERN SOM FAVORIT');
                    $('.favorite_company a img').attr('src', 'images/favcompany_hover.png');
                },
            });
        } else {
            $(this).children('.itemimg').attr('src', itemVal);
            $.ajax({
                url: urlCompany,
                type: "DELETE",
                data: {
                    id: companyid
                },
                datatype: "JSON",
                cache: false,
                beforeSend: function() {
                    // $('.overlay-loader').show();
                },
                success: function(data) {
                    // $('.overlay-loader').hide();
                    $(companyFavoriteStatus).attr('data-cfav', "false");
                    $('.favorite_company a img').attr('src', 'images/favcompany.png');
                    $('.favorite_company a span').html('Følg virksomhed');
                },
            });
        }
    });
}
function DealsFavs() {
    $('.favorite_deal').click(function(e) {
        e.preventDefault();
        var dealfavorite = $(this).parent().parent().parent().parent().find('.gallery').attr('data-fav');
        var dealFavoriteStatus = $(this).parent().parent().parent().parent().find('.gallery');
        var dealid = localStorage.dealId;
        var url;
        if (typeof usertoken != "undefined") {
            url = 'http://rappit.dk/api/deals/favs.json?token=' + usertoken;
        }
        if (typeof FBtoken != "undefined") {
            url = 'http://rappit.dk/api/deals/favs.json?ftoken=' + FBtoken;
        }
        var itemVal = $(this).attr('data');
        $(this).children('a').children('.itemimg').attr('src', itemVal);
        var itemCode = $(this).attr('data');
        if (dealfavorite === "false") {
            $(this).children('.itemImg').attr('src', itemCode + '_hover');
            $.ajax({
                url: url,
                type: "POST",
                data: {
                    id: dealid
                },
                datatype: "JSON",
                cache: false,
                beforeSend: function() {
                    // $('.overlay-loader').show();
                },
                success: function(data) {
                    // $('.overlay-loader').hide();
                    $(dealFavoriteStatus).attr('data-fav', "true");
                    $('.favorite_deal a span').html('FJERN FRA GEMTE OPSLAG');
                    $('.favorite_deal a img').attr('src', 'images/favdeal_hover.png');
                },
            });
        } else {
            $(this).children('.itemimg').attr('src', itemVal);
            $.ajax({
                url: url,
                type: "DELETE",
                data: {
                    id: dealid
                },
                datatype: "JSON",
                cache: false,
                beforeSend: function() { },
                success: function(data) {
                    // $('.overlay-loader').hide();
                    $(dealFavoriteStatus).attr('data-fav', "false");
                    $('.favorite_deal a img').attr('src', 'images/favdeal.png');
                    $('.favorite_deal a span').html('Gem opslag');
                },
            });
        }
    });
}
function RecommendedDeals() {
    $('.Recommend_deal').click(function(e) {
        e.preventDefault();
        var RecommendDeal = $(this).parent().parent().parent().parent().find('.gallery').attr('data-recommended');
        var RecommendStatus = $(this).parent().parent().parent().parent().find('.gallery');
        var dealid = $(this).parent().parent().parent().parent().find('.gallery').attr('id');
        var urlRecommended = 'http://rappit.dk/api/deal/reccommend.json?ftoken=' + FBtoken + '&id=' + dealid;
        var itemVal = $(this).attr('data');
        $(this).children('a').children('.itemimg').attr('src', itemVal);
        var itemCode = $(this).attr('data');
        if (RecommendDeal === "false") {
            $(this).children('.rec').attr('src', itemCode + '_hover');
            $.ajax({
                url: urlRecommended,
                type: "POST",
                datatype: "JSON",
                data: {
                    id: dealid
                },
                cache: false,
                beforeSend: function() {
                    // $('.overlay-loader').show();
                },
                success: function(data) {
                    // $('.overlay-loader').hide();
                    $(RecommendStatus).attr('data-recommended', "true");
                    $('.Recommend_deal a img').attr('src', 'images/thumbIcon_hover.png');
                    $('.Recommend_deal a span').html('FJERN LIKE');
                }
            });
        } else {
            $(this).children('.rec').attr('src', itemVal);
            $.ajax({
                url: urlRecommended,
                type: "DELETE",
                datatype: "JSON",
                data: {
                    id: dealid
                },
                cache: false,
                beforeSend: function() {
                    // $('.overlay-loader').show();
                },
                success: function(data) {
                    // $('.overlay-loader').hide();
                    $(RecommendStatus).attr('data-recommended', "false");
                    $('.Recommend_deal a img').attr('src', 'images/thumbIcon.png');
                    $('.Recommend_deal a span').html('Like');
                }
            });
        }
    });
}
/*================================== For Share deal through FB login ==================================*/
function ShareDeal() {
    $('.share_deal').click(function(e) {
        e.preventDefault();
        var shareDeal = $(this).parent().closest("li");
        var dealId = $(this).parents('li').attr('data-id');
        var cId = $(this).parents('li').attr('data-cid');
        var companyFav = $(this).parents('li').attr('data-companyfav');
        location.href = "share.html";
        localStorage.setItem("cid", cId);
        localStorage.setItem("dealId", dealId);
        localStorage.setItem('sharedeal', shareDeal[0].outerHTML);
        localStorage.setItem('companyfav', companyFav);
    });
}
/******************* Global function Hide company list function for all ***************************/
function HiddenCompanies(hiddenCompany, hiddenCompanyStatus, companyid) {
    var urlHideCompany;
    if (typeof usertoken != "undefined") {
        urlHideCompany = 'http://rappit.dk/api/company/hide.json?token=' + usertoken;
    }
    if (typeof FBtoken != "undefined") {
        urlHideCompany = 'http://rappit.dk/api/company/hide.json?ftoken=' + FBtoken;
    }
    var itemVal = $(this).attr('data');
    $(this).children('a').children('.itemimg').attr('src', itemVal);
    var itemCode = $(this).attr('data');
    if (hiddenCompany === "false") {
        $(this).children('.itemimg').attr('src', itemCode + '_hover');
        $.ajax({
            url: urlHideCompany,
            type: "POST",
            datatype: "JSON",
            data: {
                id: companyid
            },
            cache: false,
            beforeSend: function() {
                // $('.overlay-loader').show();
            },
            success: function(data) {
                // $('.overlay-loader').hide();
                $(hiddenCompanyStatus).attr('data-chide', data.status);
                $('.hide-company img').attr('src', 'images/hideicon_hover.png');
                $('.dealsettings ul li.hide-company a span').html('Vis Virksomhed');
            },
        });
    } else {
        $(this).children('.itemimg').attr('src', itemVal);
        $.ajax({
            url: urlHideCompany,
            type: "DELETE",
            datatype: "JSON",
            data: {
                id: companyid
            },
            cache: false,
            beforeSend: function() {
                // $('.overlay-loader').show();
            },
            success: function(data) {
                // $('.overlay-loader').hide();
					      $(hiddenCompanyStatus).attr('data-chide', data.status);
					      $('.hide-company img').attr('src', 'images/hideicon.png');
					      $('.dealsettings ul li.hide-company a span').html('Skjul virksomhed');
				    }
			  });
		}
		// });
}
//============================ CompanyDetails Function ===========================================
function companyDetails() {
		$('.coclik').click(function() {
			  var coid = $(this).attr('data-coid');
			  localStorage.setItem('cid', coid);
			  location.href = "companyprofile.html";
		});
}
//============================ Condition Check event ====================================
function conditionCheck(event) {
		var dealfavorite = $('.gallery').attr('data-fav');
		if (dealfavorite === "true") {
			  $('.favorite_deal a img').attr('src', 'images/favdeal_hover.png');
			  $('.favorite_deal a span').html('FJERN FRA GEMTE OPSLAG');
		} else {
			  $('.favorite_deal a img').attr('src', 'images/favdeal.png');
			  $('.favorite_deal a span').html('Gem opslag');
		}
		var companyfavorite = $('.gallery').attr('data-cfav');
		if (companyfavorite === "true") {
			  $('.favorite_company a img').attr('src', 'images/favcompany_hover.png');
			  $('.favorite_company a span').html('FJERN SOM FAVORIT');
		} else {
			  $('.favorite_company a img').attr('src', 'images/favcompany.png');
			  $('.favorite_company a span').html('Følg virksomhed');
		}
		var RecommendDeal = $('.gallery').attr('data-recommended');
		if (RecommendDeal === "true") {
			  $('.Recommend_deal a img').attr('src', 'images/thumbIcon_hover.png');
			  $('.Recommend_deal a span').html('FJERN LIKE');
		} else {
			  $('.Recommend_deal a img').attr('src', 'images/thumbIcon.png');
			  $('.Recommend_deal a span').html('Like');
		}
		var hiddenCompany = $('.gallery').attr('data-chide');
		if (hiddenCompany === "true") {
			  $('.hide-company img').attr('src', 'images/hideicon_hover.png');
			  $('.dealsettings ul li.hide-company a span').html('Vis Virksomhed');
		} else {
			  $('.hide-company img').attr('src', 'images/hideicon.png');
			  $('.dealsettings ul li.hide-company a span').html('Skjul virksomhed');
		}
} //END of condition check
