/********************* For Favorites Company List *****************************/
var lat = localStorage.getItem('userlat');
var lng = localStorage.getItem('userlng');
var usertoken = localStorage.token;
var FBtoken = localStorage.accessToken;

$(document).ready(function() {

	var markup = '<li data-cid="${id}"><img src="${logo.path}" class="details" alt=""><span><img src="images/close.png" alt=""></span><p><a>${name}</a></p></li>';
	$.template("favTemplate", markup);
	var url;

	if (typeof usertoken != "undefined") {
		url = 'http://rappit.dk/api/company/favs.json?token=' + usertoken + '&latitude=' + lat + '&longitude=' + lng;
	}
	if (typeof FBtoken != "undefined") {
		url = 'http://rappit.dk/api/company/favs.json?ftoken=' + FBtoken + '&latitude=' + lat + '&longitude=' + lng;
	}

	$.ajax({
		datatype: 'JSON',
		url: url,
		jsonp: "$callback",
		beforeSend: function() {
			$('.overlay-loader').show();
		},
		success: function(data) {
			$('.overlay-loader').hide();
			var companyFavs = data;
			$('.favcompany-list').empty();
			$.tmpl('favTemplate', companyFavs).appendTo(".favcompany-list");
		}
	}).done(function() {
		$('.favcompany-list li span').click(function() {
			var x = $(this).parent();
			var companyid = $(this).parent().attr('data-cid');

			if (typeof usertoken != "undefined") {
				url = 'http://rappit.dk/api/company/favs.json?token=' + usertoken + '&latitude=' + lat + '&longitude=' + lng;
			}
			if (typeof FBtoken != "undefined") {
				url = 'http://rappit.dk/api/company/favs.json?ftoken=' + FBtoken + '&latitude=' + lat + '&longitude=' + lng;
			}
			$.ajax({
				url: url,
				type: "DELETE",
				datatype: "JSON",
				data: {
					id: companyid
				},
				beforeSend: function() {
					$('.overlay-loader').show();
				},
				success: function(data) {
					$('.overlay-loader').hide();
					$(x).remove();
				}
			});
		});
	});

	/******************** For Favorite Deals **********************************/

	var favDeal = '<li id="${id}" data-id="${id}" data-cid="${company.id}" data-companyfav="${isCompanyFavoured}" data-favorite="${isDealFavoured}" data-hidecompany="${isCompanyHidden}" data-recommended="${isRecommended}" data-price="${hidePrice}" data-discount="${hideDiscount}"><div class="favdealsImg dealsImg"> <a><img src="${mainImage.path}" alt=""></a><br/></div><div class="favdealsInfo dealsInfo"><div class="favdealsBreif dealsBreif"><h3 data-dealid="${id}">${name}</h3><p class="companyTitle">${company.name}</p></div><div class="dealsIcons"><ul><li><a class="priceDiscount"><img src="images/empty.png" alt="" class="discountImg">${discount}<span class="discountPercent">%</span></a><span>${priceAfterDiscount} kr.</span></li><li><a class="navigation"><img src="images/distance.png" alt=""></a><span>${distance} km</span></li><li><a class="moresettings"><img src="images/newmenu.png" alt=""></a><span>Menu</span></li></ul></div></div></div><div class="dealsettings"><ul><li data="images/profile_icon2.png" class="favorite_company"><a><img src="images/favcompany.png" alt="" class="itemimg"><span class="company-txt"> Følg virksomhed</span></a></li><li data="images/favdeal_hover.png" class="favorite_deal"><a><img src="images/favdeal.png" alt="" class="itemimg"><span class="deal-txt">Gem opslag</span></a></li><li data="images/thumbIcon_hover.png" class="Recommend_deal_nearest"><a><img src="images/thumbIcon.png" alt="" class="itemimg"> <span>Like</span></a></li><li data="images/shareicon_hover.png" class="share_deal"><a href="share.html"><img src="images/shareicon.png" alt="" class="itemimg"> Send til ven</a></li><li data="images/hideicon_hover.png" class="hide-company"><a><img src="images/hideicon.png" alt="" class="itemimg"> <span>Skjul virksomhed</span></a></li><li data="images/backBtn_hover.png"><a class="back"><img src="images/backBtn.png" alt="" class="itemimg"> Tilbage</a></li></ul></div></li>';
	$.template("favDealTemp", favDeal);

	var urlDealFavs;
	if (typeof usertoken != "undefined") {
		urlDealFavs = 'http://rappit.dk/api/deals/favs.json?token=' + usertoken + '&latitude=' + lat + '&longitude=' + lng;
	}
	if (typeof FBtoken != "undefined") {
		urlDealFavs = 'http://rappit.dk/api/deals/favs.json?ftoken=' + FBtoken + '&latitude=' + lat + '&longitude=' + lng;
	}

	$.ajax({
		datatype: 'JSON',
		url: urlDealFavs,
		jsonp: "$callback",
		beforeSend: function() {
			// $('.overlay-loader').show();
		},
		success: function(data) {
			console.log(data);
			// $('.overlay-loader').hide();
			var dealFavs = data;
			$('.favdealsList').empty();
			$.tmpl('favDealTemp', dealFavs).appendTo(".favdealsList");
		}
	}).done(function() {
		dealsDetails();
		companyDetails();
		ShareDeal();
		RecommendedDeals();

		if (typeof usertoken != "undefined") {
			$('.dealsettings ul li:nth-child(3)').hide();
			$('.dealsettings ul li:nth-child(4)').hide();
			$('.dealsettings').css({
				'height': '220px !important'
			});
		}
		if (typeof FBtoken != "undefined") {
			$('.dealsettings ul li:nth-child(3)').show();
			$('.dealsettings ul li:nth-child(4)').show();
			$('.dealsettings').css({
				'min-height': '330px'
			});
		}

		$('.moresettings').click(function(e) {
			var dealfavorite = $(this).parent().parent().parent().attr('data-favorite');
			if (dealfavorite === "true") {
				$('.dealsettings ul li.favorite_deal a img').attr('src', 'images/favdeal_hover.png');
				$('.dealsettings ul li.favorite_deal a span').html('FJERN FRA GEMTE OPSLAG');
			} else {
				$('.dealsettings ul li.favorite_deal a img').attr('src', 'images/favdeal.png');
				$('.dealsettings ul li.favorite_deal a span').html('Gem opslag');
			}

			var companyfavorite = $(this).parent().parent().parent().attr('data-companyfav');
			if (companyfavorite === "true") {
				$('.dealsettings ul li.favorite_company a img').attr('src', 'images/profile_icon2.png');
				$('.dealsettings ul li.favorite_company a span').html('FJERN SOM FAVORIT');
			} else {
				$('.dealsettings ul li.favorite_company a img').attr('src', 'images/favcompany.png');
				$('.dealsettings ul li.favorite_company a span').html('Følg virksomhed');
			}

			var hiddenCompany = $(this).parent().parent().parent().attr('data-hidecompany');
			if (hiddenCompany === "true") {
				$('.dealsettings ul li.hide-company a img').attr('src', 'images/hideicon_hover.png');
				$('.dealsettings ul li.hide-company a span').html('Vis Virksomhed');
			} else {
				$('.dealsettings ul li.hide-company a img').attr('src', 'images/hideicon.png');
				$('.dealsettings ul li.hide-company a span').html('Skjul virksomhed');
			}

			e.preventDefault();
			$('.overlay').show();
			$(this).parents().find('.dealsettings').show();
			$('.dealsettings ul').show();
		});

		$('.back').click(function(e) {
			e.preventDefault();
			$('.overlay').hide();
			$('.dealsettings').hide();
		});

		/******************* for removing dealfavs *****************/

		$('.dealsettings ul li.favorite_deal').click(function(e) {
			var x = $(this).parent().parent().parent().parent();
			var companyid = $(this).parent().parent().parent().parent().attr('data-id');
			var urlRemoveDeal;

			if (typeof usertoken != "undefined") {
				urlRemoveDeal = 'http://rappit.dk/api/deals/favs.json?token=' + usertoken;
			}
			if (typeof FBtoken != "undefined") {
				urlRemoveDeal = 'http://rappit.dk/api/deals/favs.json?ftoken=' + FBtoken;
			}

			$.ajax({
				url: urlRemoveDeal,
				type: "DELETE",
				datatype: "JSON",
				data: {
					id: companyid
				},
				beforeSend: function() {
					// $('.overlay-loader').show();
				},
				success: function(data) {
					// $('.overlay-loader').hide();
					$('.overlay').hide();
					$('.dealsettings').hide();
					$(x).remove();
				}
			});
		});

		$('.dealsettings ul li.favorite_company').click(function(e) {
			var y = $(this).parent().parent().parent().parent();
			var companyid = $(this).parents('li').attr('data-cid');
			var companyfavorite = $(this).parents('li').attr('data-companyfav');
			var companyFavoriteStatus = $(this).parents('li');
			var urlRemoveCompany;
			if (typeof usertoken != "undefined") {
				urlRemoveCompany = 'http://rappit.dk/api/company/favs.json?token=' + usertoken;
			}
			if (typeof FBtoken != "undefined") {
				urlRemoveCompany = 'http://rappit.dk/api/company/favs.json?ftoken=' + FBtoken;
			}

			if (companyfavorite === "true") {
				$.ajax({
					url: urlRemoveCompany,
					type: "DELETE",
					datatype: "JSON",
					data: {
						id: companyid
					},
					beforeSend: function() {
						// $('.overlay-loader').show();
					},
					success: function(data) {
						// $('.overlay-loader').hide();
						$(companyFavoriteStatus).attr('data-companyfav', data.status);
						$('.company-txt').text('Følg virksomhed');
						$('.favorite_company img').attr('src', 'images/favcompany.png');
					}
				});
			} else if (companyfavorite == "false") {
				$.ajax({
					url: urlRemoveCompany,
					type: "POST",
					datatype: "JSON",
					data: {
						id: companyid
					},
					beforeSend: function() {
						// $('.overlay-loader').show();
					},
					success: function(data) {
						// $('.overlay-loader').hide();
						$(companyFavoriteStatus).attr('data-companyfav', data.status);
						$('.company-txt').text('FJERN SOM FAVORIT');
						$('.favorite_company img').attr('src', 'images/profile_icon2.png');
					}
				});
			}
		});

		$('.dealsettings ul li.hide-company').click(function(e) {
			e.preventDefault();

			var hiddenCompany = $(this).parents('li').attr('data-hidecompany');
			var z = $(this).parent().parent().parent().parent();
			var companyid = $(this).parent().parent().parent().parent().attr('data-id');
			var urlHideCompany;

			if (hiddenCompany == 'false') {
				navigator.notification.confirm(
					'Er du sikker på, at du vil skjule virksomheden?',
					function(button) {
						if (button == 1) {
							HiddenCompanies(hiddenCompany, z, companyid, urlHideCompany);
							$(z).remove();
						}
					}, 'Bekræft', 'Ok,Annuler' // title
				);
			}
		});

		// Leave out price and discount

		$('ul.favdealsList > li').each(function() {
			var hidePrice = $(this).attr('data-price');
			var hideDiscount = $(this).attr('data-discount');

			$(this).children().find('.discountPercent').replaceWith('%');
		});
	}); //End of DONE function
}); //end of Favorites js


/*================================== For Hiden company function ==================================*/

function HiddenCompanies(hiddenCompany, z, companyid, urlHideCompany) {
	if (typeof usertoken != "undefined") {
		urlHideCompany = 'http://rappit.dk/api/deals/favs.json?token=' + usertoken;
	}
	if (typeof FBtoken != "undefined") {
		urlHideCompany = 'http://rappit.dk/api/deals/favs.json?ftoken=' + FBtoken;
	}

	$.ajax({
		url: urlHideCompany,
		type: "DELETE",
		datatype: "JSON",
		data: {
			id: companyid
		},
		beforeSend: function() {
			// $('.overlay-loader').show();
		},
		success: function(data) {
			// $('.overlay-loader').hide();
			$('.overlay').hide();
			$('.dealsettings').hide();
			$(z).remove();
		}
	});
	// });
}

/*================================== For Share deal through FB login ==================================*/

function ShareDeal() {
	$('.share_deal').click(function(e) {
		e.preventDefault();
		var shareDeal = $(this).parent().closest("li");
		var dealId = $(this).parents('li').attr('data-id');
		var cId = $(this).parents('li').attr('data-cid');
		var companyFav = $(this).parents('li').attr('data-companyfav');
		location.href = "share.html";
		localStorage.setItem("cid", cId);
		localStorage.setItem("dealId", dealId);
		localStorage.setItem('sharedeal', shareDeal[0].outerHTML);
		localStorage.setItem('companyfav', companyFav);
	});
}

//============================= Like Function (FB Login Only) =============================

function RecommendedDeals() {
	$('.Recommend_deal_nearest').click(function(e) {
		e.preventDefault();
		var RecommendDeal = $(this).parents('li').attr('data-recommended');
		var RecommendStatus = $(this).parents('li');
		var dealid = $(this).parents('li').data('id');
		var urlRecommended = 'http://rappit.dk/api/deal/reccommend.json?ftoken=' + FBtoken + '&id=' + dealid;

		var itemVal = $(this).attr('data');
		$(this).children('a').children('.itemimg').attr('src', itemVal);
		var itemCode = $(this).attr('data');

		if (RecommendDeal === "false") {
			$(this).children('.itemImg').attr('src', itemCode + '_hover');
			$.ajax({
				url: urlRecommended,
				type: "POST",
				datatype: "JSON",
				data: {
					id: dealid
				},
				cache: false,
				beforeSend: function() {
					// $('.overlay-loader').show();
				},
				success: function(data) {
					// $('.overlay-loader').hide();
					$(RecommendStatus).attr('data-recommended', data.status);
					$('.Recommend_deal_nearest img').attr('src', 'images/thumbIcon_hover.png');
					$('.Recommend_deal_nearest a span').html('FJERN LIKE');
				}
			});
		} else {
			$(this).children('.itemimg').attr('src', itemVal);
			$.ajax({
				url: urlRecommended,
				type: "DELETE",
				datatype: "JSON",
				data: {
					id: dealid
				},
				cache: false,
				beforeSend: function() {
					// $('.overlay-loader').show();
				},
				success: function(data) {
					// $('.overlay-loader').hide();
					$(RecommendStatus).attr('data-recommended', data.status);
					$('.Recommend_deal_nearest img').attr('src', 'images/thumbIcon.png');
					$('.Recommend_deal_nearest a span').html('Like');
				}
			});
		}
	});
}

//============================= Condition Check Function ==================================


function conditionCheck(event) {

		var dealfavorite = $(event.currentTarget).parent().parent().parent().attr('data-favorite');
		if (dealfavorite === "true") {
			$(event.currentTarget).parent().parent().next().find('.favorite_deal img').attr('src', 'images/favdeal_hover.png');
			$('.dealsettings ul li.favorite_deal a span').html('FJERN FRA GEMTE OPSLAG');
		} else {
			$(event.currentTarget).parent().parent().next().find('.favorite_deal img').attr('src', 'images/favdeal.png');
			$('.dealsettings ul li.favorite_deal a span').html('Gem opslag');
		}

		var companyfavorite = $(event.currentTarget).parent().parent().parent().attr('data-companyfav');
		if (companyfavorite === "true") {
			$(event.currentTarget).parent().parent().next().find('.favorite_company img').attr('src', 'images/profile_icon2.png');
			$('.dealsettings ul li.favorite_company a span').html('FJERN SOM FAVORIT');
		} else {
			$(event.currentTarget).parent().parent().next().find('.favorite_company img').attr('src', 'images/favcompany.png');
			$('.dealsettings ul li.favorite_company a span').html('Følg virksomhed');
		}

		var hiddenCompany = $(event.currentTarget).parent().parent().parent().attr('data-hidecompany');
		if (hiddenCompany === "true") {
			$(event.currentTarget).parent().parent().parent().next().find('.hide-company img').attr('src', 'images/hideicon_hover.png');
			$('.dealsettings ul li.hide-company a span').html('Vis Virksomhed');
		} else {
			$(event.currentTarget).parent().parent().parent().next().find('.hide-company img').attr('src', 'images/hideicon.png');
			$('.dealsettings ul li.hide-company a span').html('Skjul virksomhed');
		}
	} //END of condition check

//=========================================== Link to Deals Details page ==============================================

function dealsDetails() {
	$('.favdealsBreif h3').click(function() {
		var dealId = $(this).parent().parent().parent().attr('data-id');
		var cId = $(this).parent().parent().parent().attr('data-cid');
		location.href = "deals-details.html";
		localStorage.setItem("dealId", dealId);
		localStorage.setItem("cid", cId);
	});

	$('.dealdescription').click(function() {
		var dealId = $(this).prev().attr('data-dealid');
		var cId = $(this).parents('li').attr('data-cid');
		location.href = "deals-details.html";
		localStorage.setItem("dealId", dealId);
		localStorage.setItem("cid", cId);
	});

	$('.dealsImg a img').click(function() {
		var dealId = $(this).parents('li').attr('data-id');
		var cId = $(this).parents('li').attr('data-cid');
		location.href = "deals-details.html";
		localStorage.setItem("dealId", dealId);
		localStorage.setItem("cid", cId);
	});
}

function companyDetails() {
	$('.favcompany-list li img.details').click(function() {
		var cId = $(this).parents('li').attr('data-cid');
		location.href = "companyprofile.html";
		localStorage.setItem("cid", cId);
	});

	$('.coName').click(function() {
		var cId = $(this).parents('li').attr('data-cid');
		localStorage.setItem("cid", cId);
		location.href = "companyprofile.html";
	});
}
