var usertoken = localStorage.token;
var FBtoken = localStorage.accessToken;
var userlat = localStorage.getItem('userlat');
var userlng = localStorage.getItem('userlng');

var link, latc, langc, marker, currpos, infowindow, contentStringCompany;
var cId = localStorage.cid;
var Status = localStorage.status;
var dummy;
var uniques;
var infowindow;
var newcats;
var selectedCat;

if (!isNumber(userlat) || !isNumber(userlng)) {
	alert("GPS-funktionen er slået fra. Venligst slå den til for at bruge kort-funktionen");
	navigator.app.backHistory();
} else {
	/************************* initializing of maps ******************************/
	initialize();
}

function initialize(catss, b) {
	if (typeof usertoken != "undefined" && typeof b == "undefined") {
		link = 'http://rappit.dk/api/map.json?token=' + usertoken + '&latitude=' + userlat + '&longitude=' + userlng;
	} else if (typeof usertoken != "undefined" && typeof b != "undefined") {
		link = 'http://rappit.dk/api/map.json?token=' + usertoken + '&latitude=' + userlat + '&longitude=' + userlng + '&category=' + selectedCat;
	} else if (typeof FBtoken != "undefined" && typeof b == "undefined") {
		link = 'http://rappit.dk/api/map.json?ftoken=' + FBtoken + '&latitude=' + userlat + '&longitude=' + userlng;
	} else if (typeof FBtoken != "undefined" && typeof b != "undefined") {
		link = 'http://rappit.dk/api/map.json?ftoken=' + FBtoken + '&latitude=' + userlat + '&longitude=' + userlng + '&category=' + selectedCat;
	}

	var mapOptions = {
		zoom: 12,
		mapTypeId: google.maps.MapTypeId.ROADMAP
	};

	var map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);

	document.addEventListener("deviceready", onDeviceReadyGeo, false);
	if(!window.plugins) onDeviceReadyGeo(); // for testing in browser

	function handleNoGeolocation(errorFlag) {
		var content = '';
		if (errorFlag) {
			content = 'Error: The Geolocation service failed.';
		} else {
			content = 'Error: Your browser doesn\'t support geolocation,please update to the latest version of your browser.';
		}
		var options = {
			map: map,
			position: new google.maps.LatLng(55.6761, 12.5683),
			content: content
		};
		var infowindow = new google.maps.InfoWindow(options);
		infowindow.close();
	}

	function onDeviceReadyGeo() {
		// [git-change: removed: retriving location from navigator ]
		currpos = new google.maps.LatLng(userlat, userlng);
		var homemarker = new google.maps.Marker({
			position: currpos,
			map: map,
			icon: 'images/home-marker.png',
			draggable: false,
		});
		map.setCenter(currpos);
	}

	$.ajax({
		type: 'GET',
		datatype: "JSON",
		url: link,
		success: function(data) {
			marker = "";
			$.each(data, function(i, v) {
				var pos = "";
				pos = new google.maps.LatLng(v.latitude, v.longitude);
				marker = "";
				marker = new google.maps.Marker({
					position: pos,
					map: map,
					icon: { url: v.marker_image },
					draggable: false,
					dealId: v.id,
				});

				google.maps.event.addListener(marker, 'click', function(marker, i) {
					contentStringCompany = "<div style='width: 180px;display: block;overflow:show;font-size: 14px;><a class='company-info' data-icid='" + v.id + "'" + " onclick=redirect(this)><span class='company-info-left'><span class='company-info-right'><span class='company-name'>" + v.name + "</span><span class='company-desc'>" + v.description + "</span><span class='total-deals-count'>Tilbud, nyhed eller event: " + v.todalDeals + "</span></span></a><span style='position:absolute; bottom:0px; left:0px; width:100%; text-align:left'>Klik Her <img src='images/detailsimg.png' alt='' width='12'></span></div>";

					if (infowindow)
						infowindow.close(); // keep only one infowindow open at a time

					infowindow = new google.maps.InfoWindow({
						position: pos,
						content: contentStringCompany
					});
					infowindow.open(map, this);
				});
				google.maps.event.addListener(map, 'click', function() {
					infowindow.close();
				});

			});
		}
	});
}


$('.dropdown ul li a').click(function(e) {
	e.preventDefault();
	dummy = "demo";
	$('.dropdown ul li').addClass('transparent');
	$(this).parent().removeClass('transparent');
	$('.selectedArrow').hide();
	$(this).children('selectedArrow').hide();
	selectedCat = $(this).attr('data-cat');
	initialize(selectedCat, dummy);
	$(this).parent().find('.selectedArrow').show();
	$('.uparrow').hide();
	$('.drop').show();
	$('.dropdown').hide();
});

$('.showall').click(function() {
	$('.dropdown ul li').addClass('transparent');
	$('.selectedArrow').hide();
	dummy = "undefined";
	selectedCat = "";
	initialize(selectedCat, dummy);
	$('.uparrow').hide();
	$('.drop').show();
	$('.dropdown').hide();
});



function isNumber(n) {
	return !isNaN(parseFloat(n)) && isFinite(n);
}